package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

import java.security.Permission;
import java.util.ArrayList;


/** Create a `PeopleTest` class.
 * Create a `testAdd` method which ensures that our `personList` in our `People`
 * class populated with respective `Person` objects
 * Create a `testRemoveByPerson` method which ensures that the `personList` in a `People`
 * object is **depopulated** with a respective `Person` object following the invokation of the `remove` method.
 * * Create a `testFindById` method which ensures that a respective `Person` object with a respective `id`
 * field is returned upon invokation of the `findById` method on a respective `People` object.
*/

public class PeopleTest {
    @Test
    public void testAdd()
    {
       People pl=new People();
        Person p=new Person("John_1",1);
        pl.addPerson(p ) ;
        Assert.assertEquals(1, pl.getCount() );
    }


  @Test
  public void testRemoveByPerson()
  {
      People pl=new People();
      Person p=new Person("john_3",3);
      pl.addPerson(new Person("john_1", 1)) ;
      pl.addPerson(new Person("john_2", 2)) ;
      pl.addPerson(new Person("john_3", 3)) ;
      pl.addPerson(new Person("john_4", 4)) ;
      pl.addPerson(new Person("john_5", 5)) ;
      pl.addPerson(new Person("john_6", 6)) ;
      pl.addPerson(new Person("john_7", 7)) ;
      pl.addPerson(new Person("john_8", 8)) ;

      pl.removeByPerson(p) ;
      Assert.assertEquals(7,pl.getCount() ) ;
  }


    @Test
    public void testRemoveByID()
    {
        People pl=new People();
        Person p=new Person("john_3",3);
        pl.addPerson(new Person("john_1", 1)) ;
        pl.addPerson(new Person("john_2", 2)) ;
        pl.addPerson(new Person("john_3", 3)) ;
        pl.addPerson(new Person("john_4", 4)) ;
        pl.addPerson(new Person("john_5", 5)) ;
        pl.addPerson(new Person("john_6", 6)) ;
        pl.addPerson(new Person("john_7", 7)) ;
        pl.addPerson(new Person("john_8", 8)) ;

        pl.removeById(p.getId()) ;
        Assert.assertEquals(7,pl.getCount() ) ;
    }

  /*
   * * Create a `testFindById` method which ensures that a respective `Person` object with a respective `id`
   * field is returned upon invokation of the `findById` method on a respective `People` object.

   */
    @Test
    public void testFindById()
    {
        People pl=new People();
        Person expected=new Person("john_1",1);
        pl.addPerson(new Person("john_1", 1)) ;
        pl.addPerson(new Person("john_2", 2)) ;
        pl.addPerson(new Person("john_3", 3)) ;
        pl.addPerson(new Person("john_4", 4)) ;
        pl.addPerson(new Person("john_5", 5)) ;
        pl.addPerson(new Person("john_6", 6)) ;
        pl.addPerson(new Person("john_7", 7)) ;
        pl.addPerson(new Person("john_8", 8)) ;

        Person actualPerson = pl.findById(expected.getId() );
        Assert.assertEquals(expected.getId(),actualPerson.getId()  ) ;

    }

    /*
      Create a `testGetArray` which ensures the array has all the people added

     */@Test
     public void testGetArray()
     {
         People pl=new People();
         pl.addPerson(new Person("john_1", 1)) ;
         pl.addPerson(new Person("john_2", 2)) ;
         pl.addPerson(new Person("john_3", 3)) ;
         pl.addPerson(new Person("john_4", 4)) ;
         pl.addPerson(new Person("john_5", 5)) ;
         pl.addPerson(new Person("john_6", 6)) ;
         pl.addPerson(new Person("john_7", 7)) ;
         pl.addPerson(new Person("john_8", 8)) ;

        ArrayList < Person> expected= pl.getArray();
        Assert.assertEquals(pl.getCount(),expected.size() ) ;

     }

   /* Create a `testRemoveAll` method which ensures you remove all the person added

     */
   @Test
    public void testRemoveAll()
   {
       People pl=new People();
       pl.addPerson(new Person("john_1", 1)) ;
       pl.addPerson(new Person("john_2", 2)) ;
       pl.addPerson(new Person("john_3", 3)) ;
       pl.addPerson(new Person("john_4", 4)) ;
       pl.addPerson(new Person("john_5", 5)) ;
       pl.addPerson(new Person("john_6", 6)) ;
       pl.addPerson(new Person("john_7", 7)) ;
       pl.addPerson(new Person("john_8", 8)) ;
       pl.removeAll() ;
      Assert.assertEquals(0,pl.getCount() );
   }
}